diff -urN Android_6.0.1_r11/frameworks/base/services/core/java/com/android/server/distribute/TaskExecutor.java SAMD_6.0.1_r11_20170930/frameworks/base/services/core/java/com/android/server/distribute/TaskExecutor.java
--- Android_6.0.1_r11/frameworks/base/services/core/java/com/android/server/distribute/TaskExecutor.java	1970-01-01 09:00:00.000000000 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/services/core/java/com/android/server/distribute/TaskExecutor.java	2017-01-29 02:51:16.793858000 +0900
@@ -0,0 +1,137 @@
+package com.android.server.distribute;
+
+import java.io.IOException;
+import java.io.ObjectInputStream;
+import java.io.ObjectOutputStream;
+import java.net.ServerSocket;
+import java.net.Socket;
+
+import android.util.Log;
+
+public class TaskExecutor extends Thread
+{
+	private static final String TAG = "TaskExecutor";
+	private static final int DISTRIBUTED_COMPUTING_PORT = 55556;
+	
+	long execution_time = 0;
+	
+	ServerSocket serverSocket;
+	Socket socket;
+	
+	ObjectOutputStream outToClient;
+	ObjectInputStream inFromClient;
+	
+	TaskRequest task;
+	Object result;
+	
+	private static boolean isConnected = false;
+	
+	public void terminate()
+	{
+		try
+		{
+			outToClient.close();
+			inFromClient.close();
+			socket.close();
+		}
+		catch(IOException e)
+		{
+			e.printStackTrace();
+		}
+	}
+	
+	//Socket client;
+	@Override
+	public void run()
+	{
+		try
+		{
+			socket = null;
+			serverSocket = new ServerSocket(DISTRIBUTED_COMPUTING_PORT);
+			
+			
+			
+			long start, end;
+			
+			while (!Thread.currentThread().isInterrupted())
+			{
+				Log.d(TAG, "TaskExecutor successfully started!");
+				socket = serverSocket.accept();
+				isConnected = true;
+				Log.d(TAG, socket.getInetAddress() + "connected.");
+				
+				outToClient = new ObjectOutputStream(socket.getOutputStream());
+				inFromClient = new ObjectInputStream(socket.getInputStream());
+				
+				while(isConnected)
+				{
+					task = (TaskRequest)inFromClient.readObject();
+					Log.d(TAG, "Request!!!!");
+					
+					start = System.currentTimeMillis();
+					
+					result = handleTask(task);
+					Log.d(TAG, "result: " + result);
+					
+					end = System.currentTimeMillis();
+					
+					if(result != null)
+						outToClient.writeObject(result);
+					//outToClient.reset();
+					
+					execution_time += (end-start);
+					
+					//outToClient.writeObject(handleTask((TaskRequest)inFromClient.readObject()));
+					
+					/*
+					Class<?> cls = Class.forName(task.name);
+					Object obj = cls.newInstance();
+					
+					Method method = cls.getDeclaredMethod("execute", Integer.class);
+					method.invoke(obj, 4);*/
+				}
+				
+				outToClient.close();
+				inFromClient.close();
+				socket.close();
+				
+				outToClient = null;
+				inFromClient = null;
+				socket = null;
+				task = null;
+				result = null;
+				execution_time = 0;
+				//Toast.makeText(mContext, "Client Connected: " + socket.getInetAddress().getHostAddress(), Toast.LENGTH_SHORT).show();
+				
+			}
+			//socket.close();
+			
+		} 
+		catch (IOException e) {
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+		} 
+		catch (ClassNotFoundException e) {
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+		}
+	}
+	
+	private Object handleTask(TaskRequest task)
+	{
+		Object result = null;
+		
+		if(task.name.equals("SUM"))
+		{
+			Log.d(TAG, "SUM!!!");
+			result = new Sum((Integer)task.parameters.get(0), (Integer)task.parameters.get(1)).execute();
+		}
+		else if(task.name.equals("BYE"))
+		{
+			Log.d(TAG, "BYE!!!");
+			isConnected = false;
+		}
+		
+		return result;
+	}
+}
diff -urN Android_6.0.1_r11/frameworks/base/services/core/java/com/android/server/distribute/Task.java SAMD_6.0.1_r11_20170930/frameworks/base/services/core/java/com/android/server/distribute/Task.java
--- Android_6.0.1_r11/frameworks/base/services/core/java/com/android/server/distribute/Task.java	1970-01-01 09:00:00.000000000 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/services/core/java/com/android/server/distribute/Task.java	2017-01-29 02:51:16.789858000 +0900
@@ -0,0 +1,6 @@
+package com.android.server.distribute;
+
+public interface Task<T> 
+{
+	T execute();
+}
diff -urN Android_6.0.1_r11/frameworks/base/services/core/java/com/android/server/distribute/TaskRequest.java SAMD_6.0.1_r11_20170930/frameworks/base/services/core/java/com/android/server/distribute/TaskRequest.java
--- Android_6.0.1_r11/frameworks/base/services/core/java/com/android/server/distribute/TaskRequest.java	1970-01-01 09:00:00.000000000 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/services/core/java/com/android/server/distribute/TaskRequest.java	2017-01-29 02:51:16.789858000 +0900
@@ -0,0 +1,17 @@
+package com.android.server.distribute;
+
+import java.io.Serializable;
+import java.util.ArrayList;
+
+public class TaskRequest implements Serializable
+{
+	private static final long serialVersionUID = 1L;
+	public String name;
+	public ArrayList<Object> parameters;
+	
+	public TaskRequest(String name, ArrayList<Object> parameters)
+	{
+		this.name = name;
+		this.parameters = parameters;
+	}
+}
diff -urN Android_6.0.1_r11/frameworks/base/services/core/java/com/android/server/location/RemoteLocationProvider.java SAMD_6.0.1_r11_20170930/frameworks/base/services/core/java/com/android/server/location/RemoteLocationProvider.java
--- Android_6.0.1_r11/frameworks/base/services/core/java/com/android/server/location/RemoteLocationProvider.java	1970-01-01 09:00:00.000000000 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/services/core/java/com/android/server/location/RemoteLocationProvider.java	2017-01-29 02:51:16.753857000 +0900
@@ -0,0 +1,153 @@
+package com.android.server.location;
+
+import java.io.FileDescriptor;
+import java.io.PrintWriter;
+
+import com.android.internal.location.ProviderProperties;
+import com.android.internal.location.ProviderRequest;
+
+import android.content.Context;
+import android.location.Criteria;
+import android.location.LocationManager;
+import android.location.LocationProvider;
+import android.os.Bundle;
+import android.os.ServiceManager;
+import android.os.WorkSource;
+import android.service.remote.IRemoteService;
+
+public class RemoteLocationProvider implements LocationProviderInterface 
+{
+	//private final String mName;
+    private final ProviderProperties mProperties = new ProviderProperties(
+            false, false, false, false, false, false, false,
+            Criteria.POWER_LOW, Criteria.ACCURACY_COARSE);
+    
+    //private final ILocationManager mLocationManager;
+
+    //private final Location mLocation;
+    private final Bundle mExtras = new Bundle();
+
+    private int mStatus;
+    private long mStatusUpdateTime;
+    private boolean mHasLocation;
+    private boolean mHasStatus;
+    private boolean mEnabled;
+    
+    private IRemoteService mRemoteService;
+
+    private static final String TAG = "RemoteLocationProvider";
+
+    public RemoteLocationProvider()
+    {
+    	mRemoteService = IRemoteService.Stub.asInterface(ServiceManager
+				.getService(Context.REMOTE_SERVICE));
+    }
+    
+    /*public RemoteLocationProvider(String name, ILocationManager locationManager,
+            ProviderProperties properties) {
+        if (properties == null) throw new NullPointerException("properties is null");
+
+        mName = name;
+        mLocationManager = locationManager;
+        mProperties = properties;
+        mLocation = new Location(name);
+    }*/
+
+    @Override
+    public String getName() {
+        return LocationManager.REMOTE_PROVIDER;
+    }
+
+    @Override
+    public ProviderProperties getProperties() {
+        return mProperties;
+    }
+
+    @Override
+    public void disable() {
+        mEnabled = false;
+    }
+
+    @Override
+    public void enable() {
+    	//if(mRemoteService)
+        mEnabled = true;
+    }
+
+    @Override
+    public boolean isEnabled() {
+        return mEnabled;
+    }
+
+    @Override
+    public int getStatus(Bundle extras) {
+        if (mHasStatus) {
+            extras.clear();
+            extras.putAll(mExtras);
+            return mStatus;
+        } else {
+            return LocationProvider.AVAILABLE;
+        }
+    }
+
+    @Override
+    public long getStatusUpdateTime() {
+        //return mStatusUpdateTime;
+    	return -1;
+    }
+
+    /*public void setLocation(Location l) {
+        mLocation.set(l);
+        mHasLocation = true;
+        if (mEnabled) {
+            try {
+                mLocationManager.reportLocation(mLocation, false);
+            } catch (RemoteException e) {
+                Log.e(TAG, "RemoteException calling reportLocation");
+            }
+        }
+    }*/
+
+    /*public void clearLocation() {
+        mHasLocation = false;
+    }
+
+    public void setStatus(int status, Bundle extras, long updateTime) {
+        mStatus = status;
+        mStatusUpdateTime = updateTime;
+        mExtras.clear();
+        if (extras != null) {
+            mExtras.putAll(extras);
+        }
+        mHasStatus = true;
+    }
+
+    public void clearStatus() {
+        mHasStatus = false;
+        mStatusUpdateTime = 0;
+    }*/
+
+    @Override
+    public void dump(FileDescriptor fd, PrintWriter pw, String[] args) {
+        dump(pw, "");
+    }
+
+    public void dump(PrintWriter pw, String prefix) {
+        /*pw.println(prefix + mName);
+        pw.println(prefix + "mHasLocation=" + mHasLocation);
+        pw.println(prefix + "mLocation:");
+        mLocation.dump(new PrintWriterPrinter(pw), prefix + "  ");
+        pw.println(prefix + "mHasStatus=" + mHasStatus);
+        pw.println(prefix + "mStatus=" + mStatus);
+        pw.println(prefix + "mStatusUpdateTime=" + mStatusUpdateTime);
+        pw.println(prefix + "mExtras=" + mExtras);*/
+    }
+
+    @Override
+    public void setRequest(ProviderRequest request, WorkSource source) { }
+
+    @Override
+    public boolean sendExtraCommand(String command, Bundle extras) {
+        return false;
+    }
+}
diff -urN Android_6.0.1_r11/frameworks/base/services/core/java/com/android/server/LocationManagerService.java SAMD_6.0.1_r11_20170930/frameworks/base/services/core/java/com/android/server/LocationManagerService.java
--- Android_6.0.1_r11/frameworks/base/services/core/java/com/android/server/LocationManagerService.java	2017-09-27 02:07:57.459736001 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/services/core/java/com/android/server/LocationManagerService.java	2017-01-29 02:51:16.441854000 +0900
@@ -39,6 +39,7 @@
 import com.android.server.location.LocationRequestStatistics.PackageStatistics;
 import com.android.server.location.MockProvider;
 import com.android.server.location.PassiveProvider;
+import com.android.server.location.RemoteLocationProvider;
 
 import android.app.AppOpsManager;
 import android.app.PendingIntent;
@@ -2602,6 +2603,33 @@
             mockProvider.clearStatus();
         }
     }
+    
+    @Override
+	public void setRemoteProviderEnabled(boolean enabled)
+			throws RemoteException
+	{
+    	synchronized (mLock) 
+    	{
+    		Log.d(TAG, "Enabled: " + enabled);
+    		
+    		long identity = Binder.clearCallingIdentity();
+            if (enabled) {
+            	RemoteLocationProvider provider = new RemoteLocationProvider();
+                addProviderLocked(provider);
+                provider.enable();
+                mEnabledProviders.add(provider.getName());
+                mDisabledProviders.remove(provider.getName());
+            } else {
+            	LocationProviderInterface provider = mProvidersByName.get(LocationManager.REMOTE_PROVIDER);
+            	removeProviderLocked(provider);
+                provider.disable();
+                mEnabledProviders.remove(provider.getName());
+                mDisabledProviders.add(provider.getName());
+            }
+            updateProvidersLocked();
+            Binder.restoreCallingIdentity(identity);
+        }
+	}
 
     private void log(String log) {
         if (Log.isLoggable(TAG, Log.VERBOSE)) {
diff -urN Android_6.0.1_r11/frameworks/base/services/core/java/com/android/server/pm/Installer.java SAMD_6.0.1_r11_20170930/frameworks/base/services/core/java/com/android/server/pm/Installer.java
--- Android_6.0.1_r11/frameworks/base/services/core/java/com/android/server/pm/Installer.java	2017-09-27 02:07:57.519736000 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/services/core/java/com/android/server/pm/Installer.java	2017-08-05 14:50:48.811606000 +0900
@@ -120,7 +120,63 @@
         builder.append(uid);
         return mInstaller.execute(builder.toString());
     }
+    
+    // ADDED FOR COLLABOROID
+    public int aapt_package(String resPath, String manifestPath, String outputApk)
+    {
+    	StringBuilder builder = new StringBuilder("aaptpackage");
+    	builder.append(' ');
+        builder.append(resPath);
+        builder.append(' ');
+        builder.append(manifestPath);
+        builder.append(' ');
+        builder.append(outputApk);
+        
+        return mInstaller.execute(builder.toString());
+    }
+    // ADDED FOR SAMD
+    public int aapt_package_with_assets(String resPath, String assetsPath, String manifestPath, String outputApk)
+    {
+        StringBuilder builder = new StringBuilder("aaptpackagewithassets");
+        builder.append(' ');
+        builder.append(resPath);
+        builder.append(' ');
+        builder.append(assetsPath);
+        builder.append(' ');
+        builder.append(manifestPath);
+        builder.append(' ');
+        builder.append(outputApk);
 
+        return mInstaller.execute(builder.toString());
+    }
+    
+    public int aapt_add(int type, String apkPath, String filePath)
+    {
+    	StringBuilder builder = new StringBuilder("aaptadd");
+    	builder.append(' ');
+        builder.append(type);
+    	builder.append(' ');
+        builder.append(apkPath);
+        builder.append(' ');
+        builder.append(filePath);
+        
+        return mInstaller.execute(builder.toString());
+    }
+    
+    public int makeodex(String dexPath, String outPath, String pkgName)
+    {
+    	StringBuilder builder = new StringBuilder("makeodex");
+        builder.append(' ');
+        builder.append(dexPath);
+        builder.append(' ');
+        builder.append(outPath);
+        builder.append(' ');
+        builder.append(pkgName);
+        
+        return mInstaller.execute(builder.toString());
+    }
+    // ADDED FOR COLLABOROID
+    
     public int movedex(String srcPath, String dstPath, String instructionSet) {
         if (!isValidInstructionSet(instructionSet)) {
             Slog.e(TAG, "Invalid instruction set: " + instructionSet);
@@ -136,6 +192,21 @@
         builder.append(instructionSet);
         return mInstaller.execute(builder.toString());
     }
+    
+    // ADDED FOR COLLABOROID
+    public int movefile(String srcPath, String dstPath) {
+        /*if (!isValidInstructionSet(instructionSet)) {
+            Slog.e(TAG, "Invalid instruction set: " + instructionSet);
+            return -1;
+        }*/
+
+        StringBuilder builder = new StringBuilder("movefile");
+        builder.append(' ');
+        builder.append(srcPath);
+        builder.append(' ');
+        builder.append(dstPath);
+        return mInstaller.execute(builder.toString());
+    }
 
     public int rmdex(String codePath, String instructionSet) {
         if (!isValidInstructionSet(instructionSet)) {
diff -urN Android_6.0.1_r11/frameworks/base/services/core/java/com/android/server/pm/PackageInstallerSession.java SAMD_6.0.1_r11_20170930/frameworks/base/services/core/java/com/android/server/pm/PackageInstallerSession.java
--- Android_6.0.1_r11/frameworks/base/services/core/java/com/android/server/pm/PackageInstallerSession.java	2017-09-27 02:07:57.519736000 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/services/core/java/com/android/server/pm/PackageInstallerSession.java	2017-07-13 15:02:57.242645000 +0900
@@ -60,6 +60,7 @@
 import android.system.StructStat;
 import android.util.ArraySet;
 import android.util.ExceptionUtils;
+import android.util.Log;
 import android.util.MathUtils;
 import android.util.Slog;
 
@@ -462,6 +463,7 @@
     }
 
     private void commitLocked() throws PackageManagerException {
+        Log.d("experiment install time", "commitLocked call");
         if (mDestroyed) {
             throw new PackageManagerException(INSTALL_FAILED_INTERNAL_ERROR, "Session destroyed");
         }
diff -urN Android_6.0.1_r11/frameworks/base/services/core/java/com/android/server/pm/PackageManagerService.java SAMD_6.0.1_r11_20170930/frameworks/base/services/core/java/com/android/server/pm/PackageManagerService.java
--- Android_6.0.1_r11/frameworks/base/services/core/java/com/android/server/pm/PackageManagerService.java	2017-09-27 02:07:57.527736000 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/services/core/java/com/android/server/pm/PackageManagerService.java	2017-09-12 13:14:50.537101000 +0900
@@ -226,6 +226,7 @@
 import com.android.server.pm.PermissionsState.PermissionState;
 import com.android.server.pm.Settings.DatabaseVersion;
 import com.android.server.pm.Settings.VersionInfo;
+import com.android.server.remote.Receiver;
 import com.android.server.storage.DeviceStorageMonitorInternal;
 
 import org.xmlpull.v1.XmlPullParser;
@@ -415,7 +416,9 @@
     final ServiceThread mHandlerThread;
 
     final PackageHandler mHandler;
-
+    //SAMD
+    public static Message SAMDMessage;
+    public static File SAMDFile;
     /**
      * Messages for {@link #mHandler} that need to wait for system ready before
      * being dispatched.
@@ -1191,8 +1194,10 @@
                             if (params.startCopy()) {
                                 // We are done...  look for more work or to
                                 // go idle.
-                                if (DEBUG_SD_INSTALL) Log.i(TAG,
-                                        "Checking for more work or unbind...");
+                                if (DEBUG_SD_INSTALL) {
+                                    Log.i(TAG,
+                                            "Checking for more work or unbind...");
+                                }
                                 // Delete pending install
                                 if (mPendingInstalls.size() > 0) {
                                     mPendingInstalls.remove(0);
@@ -1300,6 +1305,7 @@
                                 i++;
                             }
                         }
+
                         size = i;
                         mPendingBroadcasts.clear();
                     }
@@ -1332,6 +1338,7 @@
                 } break;
                 case POST_INSTALL: {
                     if (DEBUG_INSTALL) Log.v(TAG, "Handling post-install for " + msg.arg1);
+
                     PostInstallData data = mRunningInstalls.get(msg.arg1);
                     mRunningInstalls.delete(msg.arg1);
                     boolean deleteOld = false;
@@ -1341,6 +1348,8 @@
                         PackageInstalledInfo res = data.res;
 
                         if (res.returnCode == PackageManager.INSTALL_SUCCEEDED) {
+
+
                             final String packageName = res.pkg.applicationInfo.packageName;
                             res.removedInfo.sendBroadcast(false, true, false);
                             Bundle extras = new Bundle(1);
@@ -1436,9 +1445,7 @@
                             EventLog.writeEvent(EventLogTags.UNKNOWN_SOURCES_ENABLED,
                                 getUnknownSourcesSettings());
                         }
-                        // Force a gc to clear up things
-                        Runtime.getRuntime().gc();
-                        // We delete after a gc for applications  on sdcard.
+
                         if (deleteOld) {
                             synchronized (mInstallLock) {
                                 res.removedInfo.args.doPostDeleteLI(true);
@@ -1739,6 +1746,7 @@
                 break;
             }
             case PackageManager.INSTALL_SUCCEEDED: {
+                //Log.d("experiment install time","[PackageManagerService] PackageManager.INSTALL_SUCCEEDED");
                 extras = new Bundle();
                 extras.putBoolean(Intent.EXTRA_REPLACING,
                         res.removedInfo != null && res.removedInfo.removedPackage != null);
@@ -2000,6 +2008,9 @@
             // code, so don't dexopt it to avoid the resulting log spew.
             alreadyDexOpted.add(frameworkDir.getPath() + "/framework-res.apk");
 
+            //collaboroid resource sharing
+
+
             // Gross hack for now: we know this file is only part of
             // the boot class path for art, so don't dexopt it to
             // avoid the resulting log spew.
@@ -2075,6 +2086,7 @@
 
             // Collected privileged system packages.
             final File privilegedAppDir = new File(Environment.getRootDirectory(), "priv-app");
+            Log.d("experiment install time","[PakcageManagerService] start scanDirLI");
             scanDirLI(privilegedAppDir, PackageParser.PARSE_IS_SYSTEM
                     | PackageParser.PARSE_IS_SYSTEM_DIR
                     | PackageParser.PARSE_IS_PRIVILEGED, scanFlags, 0);
@@ -3008,6 +3020,7 @@
         synchronized (mPackages) {
             PackageParser.Activity a = mActivities.mActivities.get(component);
 
+
             if (DEBUG_PACKAGE_INFO) Log.v(TAG, "getActivityInfo " + component + ": " + a);
             if (a != null && mSettings.isEnabledLPr(a.info, flags, userId)) {
                 PackageSetting ps = mSettings.mPackages.get(component.getPackageName());
@@ -4149,6 +4162,63 @@
         }
         return 0;
     }
+    
+    // ADDED FOR COLLABOROID
+    @Override
+    public int makeodex(String dexPath, String outPath, String pkgName)
+    {
+    	int result = 0;
+    	synchronized (mPackages)
+    	{
+    		result = mInstaller.makeodex(dexPath, outPath, pkgName);
+    	}
+    	return result;
+    }
+    
+    @Override
+    public int aaptPackage(String resPath, String manifestPath, String outputApk)
+    {
+    	int result = 0;
+    	synchronized (mPackages)
+    	{
+    		result = mInstaller.aapt_package(resPath, manifestPath, outputApk);
+    	}
+    	return result;
+    }
+
+    // ADDED FOR SAMD
+    @Override
+    public int aaptPackageWithAssets(String resPath, String assetsPath, String manifestPath, String outputApk)
+    {
+        int result = 0;
+        synchronized (mPackages)
+        {
+            result = mInstaller.aapt_package_with_assets(resPath, assetsPath, manifestPath, outputApk);
+        }
+        return result;
+    }
+    
+    @Override
+    public int aaptAdd(int type, String apkPath, String filePath)
+    {
+    	int result = 0;
+    	synchronized (mPackages)
+    	{
+    		result = mInstaller.aapt_add(type, apkPath, filePath);
+    	}
+    	return result;
+    }
+    
+    @Override
+    public int movefile(String srcPath, String dstPath)
+    {
+    	int result = 0;
+    	synchronized (mPackages)
+    	{
+    		result = mInstaller.movefile(srcPath, dstPath);
+    	}
+    	return result;
+    }
 
     @Override
     public boolean isUidPrivileged(int uid) {
@@ -5622,6 +5692,19 @@
     }
 
     private void scanDirLI(File dir, int parseFlags, int scanFlags, long currentTime) {
+        if(dir.getAbsolutePath().contains("TexasHoldem")){
+            Log.d("experiment install time","[PackageManagerService] scanDirLI TexasHoldem call");
+        }
+        if(dir.getAbsolutePath().contains("TestApp")){
+            Log.d("experiment install time","[PackageManagerService] scanDirLI TestApp call");
+        }
+        if(dir.getAbsolutePath().contains("CodeIntensive")){
+            Log.d("experiment install time","[PackageManagerService] scanDirLI CodeIntensive call");
+        }
+        if(dir.getAbsolutePath().contains("ResourseIntensive")){
+            Log.d("experiment install time","[PackageManagerService] scanDirLI ResourseIntensive call");
+        }
+
         final File[] files = dir.listFiles();
         if (ArrayUtils.isEmpty(files)) {
             Log.d(TAG, "No files in app dir " + dir);
@@ -5717,6 +5800,19 @@
             Slog.w(TAG, "PackageSetting for " + ps.name
                     + " is missing signatures.  Collecting certs again to recover them.");
         } else {
+            if(srcFile.getAbsolutePath().contains("TexasHoldem")){
+                Log.d("experiment install time", "TexasHoldem install success");
+            }
+            if(srcFile.getAbsolutePath().contains("CodeIntensive")){
+                Log.d("experiment install time", "CodeIntensive install success");
+            }
+            if(srcFile.getAbsolutePath().contains("TestApp")){
+                Log.d("experiment install time", "TestApp install success");
+            }
+            if(srcFile.getAbsolutePath().contains("ResourseIntensive")){
+                Log.d("experiment install time", "ResourseIntensive install success");
+            }
+
             Log.i(TAG, srcFile.toString() + " changed; collecting certs");
         }
 
@@ -5734,7 +5830,10 @@
      */
     private PackageParser.Package scanPackageLI(File scanFile, int parseFlags, int scanFlags,
             long currentTime, UserHandle user) throws PackageManagerException {
+
+        Log.d("experiment install time","[PackageManagerServise] scanPackageLI call");
         if (DEBUG_INSTALL) Slog.d(TAG, "Parsing: " + scanFile);
+
         parseFlags |= mDefParseFlags;
         PackageParser pp = new PackageParser();
         pp.setSeparateProcesses(mSeparateProcesses);
@@ -5748,6 +5847,10 @@
         final PackageParser.Package pkg;
         try {
             pkg = pp.parsePackage(scanFile, parseFlags);
+            
+            if(pkg.packageName.contains("Dummy"))
+        		Log.d(TAG, "DUMMY!! - volume: " + pkg.volumeUuid + "pn: " +pkg.packageName);
+            
         } catch (PackageParserException e) {
             throw PackageManagerException.from(e);
         }
@@ -6304,6 +6407,10 @@
     }
 
     private int createDataDirsLI(String volumeUuid, String packageName, int uid, String seinfo) {
+    	
+    	if(packageName.contains("Dummy"))
+    		Log.d(TAG, "DUMMY!! - volume: " + volumeUuid + "pn: " +packageName + "uid: " + uid + "seinfo: " + seinfo);
+    	
         int[] users = sUserManager.getUserIds();
         int res = mInstaller.install(volumeUuid, packageName, uid, uid, seinfo);
         if (res < 0) {
@@ -6546,6 +6653,9 @@
                 Log.d(TAG, "Scanning package " + pkg.packageName);
         }
 
+        if(pkg.packageName.contains("Dummy"))
+    		Log.d(TAG, "DUMMY!! - volume: " + pkg.volumeUuid + "pn: " +pkg.packageName);
+        
         if (mPackages.containsKey(pkg.packageName)
                 || mSharedLibraries.containsKey(pkg.packageName)) {
             throw new PackageManagerException(INSTALL_FAILED_DUPLICATE_PACKAGE,
@@ -9571,12 +9681,14 @@
         final Message msg = mHandler.obtainMessage(INIT_COPY);
         msg.obj = new InstallParams(origin, null, observer, installFlags, installerPackageName,
                 null, verificationParams, user, packageAbiOverride, null);
+
         mHandler.sendMessage(msg);
     }
 
     void installStage(String packageName, File stagedDir, String stagedCid,
             IPackageInstallObserver2 observer, PackageInstaller.SessionParams params,
             String installerPackageName, int installerUid, UserHandle user) {
+        //Log.d("experiment install time", "installStage call");
         final VerificationParams verifParams = new VerificationParams(null, params.originatingUri,
                 params.referrerUri, installerUid, null);
         verifParams.setInstallerUid(installerUid);
@@ -12214,6 +12326,8 @@
             res.uid = newPackage.applicationInfo.uid;
             res.pkg = newPackage;
             mSettings.setInstallStatus(pkgName, PackageSettingBase.PKG_INSTALL_COMPLETE);
+            Log.d("experiment install time",
+                    "[PackageManagerService] updateSettingsLI PKG_INSTALL_COMPLETE");
             mSettings.setInstallerPackageName(pkgName, installerPackageName);
             res.returnCode = PackageManager.INSTALL_SUCCEEDED;
             //to update install status
@@ -12222,6 +12336,7 @@
     }
 
     private void installPackageLI(InstallArgs args, PackageInstalledInfo res) {
+        //Log.d("experiment install time","[PackageManagerService] installPackageLI call");
         final int installFlags = args.installFlags;
         final String installerPackageName = args.installerPackageName;
         final String volumeUuid = args.volumeUuid;
@@ -15779,6 +15894,7 @@
     }
 
     private void loadPrivatePackagesInner(VolumeInfo vol) {
+        Log.d("experiment install time", "[PackageManagerService] loadPrivatePackagesInner call");
         final ArrayList<ApplicationInfo> loaded = new ArrayList<>();
         final int parseFlags = mDefParseFlags | PackageParser.PARSE_EXTERNAL_STORAGE;
 
@@ -15795,6 +15911,7 @@
                 try {
                     pkg = scanPackageLI(ps.codePath, parseFlags, SCAN_INITIAL, 0L, null);
                     loaded.add(pkg.applicationInfo);
+                    Log.d("experiment install time", "[PackageManagerService] loadPrivatePackagesInner add");
                 } catch (PackageManagerException e) {
                     Slog.w(TAG, "Failed to scan " + ps.codePath + ": " + e.getMessage());
                 }
@@ -16207,6 +16324,7 @@
         final OriginInfo origin = OriginInfo.fromExistingFile(codeFile);
         msg.obj = new InstallParams(origin, move, installObserver, installFlags,
                 installerPackageName, volumeUuid, null, user, packageAbiOverride, null);
+
         mHandler.sendMessage(msg);
     }
 
